config/routes.rb
Rails.application.routes.draw do
  get 'order_items/show'
  get 'checkouts/index'
  resources :order_items
  resources :cart
  devise_for :users, :controllers => { registrations: 'registrations'}
  resources :admins
  resources :users
  resources :products
  resources :vendors
  resources :orders
  root to: "home#index"
  get 'home/index'
  post "checkout/create", to: "checkout#create"
  post "products/add_to_cart/:id", to: "products#add_to_cart", as: "add_to_cart"
  delete "products/remove_from_cart/:id", to: "products#remove_from_cart", as: "remove_from_cart"
  # resources :webhooks, only: [:create]
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/order.rb
class Order < ApplicationRecord
  has_many :order_items, dependent: :destroy
  has_one :user
end

app/models/order_item.rb
class OrderItem < ApplicationRecord
	belongs_to :order
	belongs_to :product
end

app/models/product.rb
class Product < ApplicationRecord
  belongs_to :user

  has_many_attached :images

  has_many :order_items
end

app/models/role.rb
class Role < ApplicationRecord
  has_and_belongs_to_many :users, :join_table => :users_roles
  
  belongs_to :resource,
             :polymorphic => true,
             :optional => true
  

  validates :resource_type,
            :inclusion => { :in => Rolify.resource_types },
            :allow_nil => true

  scopify
end

app/models/user.rb
class User < ApplicationRecord
  has_many :products, :dependent => :destroy
  has_many :order
  
  rolify
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable, :trackable
  
  after_create :assign_default_role

  validate :must_have_a_role, on: :update

  validate :must_have_a_role, on: :new

  after_create do 
    customer = Stripe::Customer.create(email: email)
    update(stripe_customer_id: customer.id)
  end

  private

  def must_have_a_role
    unless roles.any?
      errors.add(:roles, "Must have at least 1 role")
    end
  end

  def assign_default_role
    self.add_role(:User) if self.roles.blank?
  end

end

app/controllers/admins_controller.rb
class AdminsController < ApplicationController
    before_action :confirm_role
    def index
        @users = User.all
    end
    def show
        @user = User.find(params[:id])
    end
    def edit
        @user = User.find(params[:id])
    end
    def update
        @user = User.find(params[:id])
        if @user.update(user_params)
            redirect_to admins_path, notice: "User successfly updated."
        else
            render :edit
        end
    end
    def delete
        @user = User.find(params[:id])
    end

    def destroy
        user = User.find(params[:id]).destroy
        flash[:notice] = "User '#{user.username}' destroyed successfully."
        redirect_to(:action => 'index')
    end

    private
    def user_params
        params.require(:user).permit({role_ids: []})
    end

    def confirm_role
        unless current_user.has_role? :Admin
          redirect_to root_path, alert: "You are not authorized."
        end
    end
end

app/controllers/cart_controller.rb
class CartController < ApplicationController
  def index
    # if session[:cart]
    #   @products = Product.where(id: session[:cart])
    # end
  end 
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  # before_action :confirm_role
  def index
    if current_user.has_role? :Admin
        redirect_to admins_path
    elsif current_user.has_role? :Vendor
        redirect_to vendors_path
    else
      @products=Product.all
    end
  end
end

app/controllers/orders_controller.rb
class OrdersController < ApplicationController
  def index
    @orders=Order.all
  end

  def show
    user=User.find(params[:id])
    @order=user.order
  end

  def create
    @order=Order.new(order_params)
    if @order.save
      @order_item=(JSON.parse params[:cart]).map{|p| OrderItem.new(p)}
      k=@order_item.length
      k.times { |i| @order_item[i].order = @order }
      k.times { |i| @order_item[i].subtotal = params[:subtotal] }
      k.times { |i| @order_item[i].save }
      respond_to do |format|
        format.json { render :inline => "{}" }
      end
    else
      redirect_to 'checkouts/index'
    end
  end

  def edit
    @orde=Order.find(params[:id])
  end

  def update
    @orde = Order.find(params[:id])
    if @orde.update(update_params)
      flash[:notice] = "Order updated successfully."
      redirect_to orders_path
    else
      render('edit')
    end
  end

  def destroy
    order = Order.find(params[:id]).destroy
    flash[:notice] = "Order destroyed successfully."
    redirect_to order_path(:id => current_user.id)
  end

  private

  def order_params
    params.permit(:user_id, :address)
  end

  def order_item_params
    params.permit(:subtotal, cart: [] )
  end

  def update_params
    params.permit(:status)
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  def update
    @user = User.find(params[:id])
    if @user.update(user_params)
        redirect_to admins_path, notice: "User successfly updated."
    else
        render :edit
    end
  end

  private
  def user_params
    params.require(:user).permit({role_ids: []})
  end
end

app/controllers/vendors_controller.rb
class VendorsController < ApplicationController
  before_action :confirm_role
  def index
      
  end

  private
  def confirm_role
    unless current_user.has_role? :Vendor
      redirect_to root_path, alert: "You are not authorized."
    end
  end
end

app/helpers/admins_helper.rb
module AdminsHelper
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/cart_helper.rb
module CartHelper
end

app/helpers/checkouts_helper.rb
module CheckoutsHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/order_items_helper.rb
module OrderItemsHelper
end

app/helpers/orders_helper.rb
module OrdersHelper
end

app/helpers/product_helper.rb
module ProductHelper
end

app/helpers/registrations_helper.rb
module RegistrationsHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/helpers/vendors_helper.rb
module VendorsHelper
end

app/views/orders/edit.html.erb
<%= form_with model: @orde do |form| %>
  
  <div>
    <%= form.label :status %><br>
    <%= select_tag(:status, options_for_select([['Pending', 'Pending'], ['Delivered', 'Delivered'], ['Cancelled', 'Cancelled'] ])) %><br>
  </div>

  <div>
    <%= form.submit %>
  </div>
  
<% end %>

app/views/orders/index.html.erb
<div class="container p-3">
  <div class="row">
    <div class="col">
      <h2>All Orders</h2>
    </div>
  </div>  
  <div class="table-responsive">
    <table class="table table-striped">
      <tr class="header text-center">
        <th>Buyer</th>
        <th>Shipping Address</th>
        <th>Status</th>
        <th>Order Items</th>
        <% if current_user.has_role? :Vendor %>
        <th>Actions</th>
        <%end %>
      </tr>
      <% @orders.each do |order| %>
          <tr class="<%= cycle('odd', 'even') %> text-center">
            <td><%= User.find(order.user_id).firstname %></td>
            <td><%= order.address %></td>
            <td><%= order.status %></td>
            <td><%= link_to "View", order_item_path(:id=>order.id) %></td> 
            <% if current_user.has_role? :Vendor %>
            <td>
              <div class="row">
                <div class="col">
                  <%= link_to "Edit", edit_order_path(order) %>      
                </div>
              </div>  
            </td>
            <% end %>
          </tr>
      <% end %>
    </table>
  </div>
</div>

app/views/orders/show.html.erb
<div class="container p-3">
    <div class="col">
        <% if current_user.has_role? :User %>
            <h5><%= link_to "<< back", root_path%></h5>
        <% end %>
    </div>
    <div class="row">
        <div class="col text-center">
            <h2>All Orders</h2>
        </div>
    </div>  
    <div class="table-responsive">
        <table class="table table-striped">
        <tr class="header text-center">
            <th>Shipping Address</th>
            <th>Status</th>
            <th>Order Items</th>
            <th>Actions</th>
        </tr>
        <% @order.each do |order| %>
            <tr class="<%= cycle('odd', 'even') %> text-center">
                <td><%= order.address %></td>
                <td><%= order.status %></td>
                <td><%= link_to "View", order_item_path(:id=>order.id) %></td> 
                <td>
                <div class="row">
                    <div class="col">
                    <%= link_to "Delete Order", order_path(order), method: :delete, data: { confirm: "Are you sure?" } %>      
                    </div>
                </div>  
                </td>
            </tr>
        <% end %>
        </table>
    </div>
</div>